<!DOCTYPE html>
<html>
<head>

	<meta name="viewport" content="width=device-width, initial-scale=1, shrink-to-fit=no">

	<title>Bootstrap Flex</title>

	<link rel="stylesheet" href="https://cdn.jsdelivr.net/npm/bootstrap@4.6.2/dist/css/bootstrap.min.css" integrity="sha384-xOolHFLEh07PJGoPkLv1IbcEPTNtaed2xpHsD9ESMhqIYd0nLMwNLD69Npy4HI+N" crossorigin="anonymous">
	
</head>
<body>
	<div class="text-center">
		<h1>Bootstrap Flex</h1>
		<p>Use the d-flex class to create a flex container and transform direct children into flex items.</p>

		<h2>Centering elements</h2>
		<!-- justify-content-start: at the left; justify-content-end: at the right -->
		<!-- align-items-start: at the top; align-items-end: at the bottom -->
		<!-- flex-column: arranges flexes in column form; flex-column-reverse: reverses the order or divs-->

		<div style="height: 500px;" class="bg-secondary d-flex justify-content-center align-items-center flex-column-reverse">
			<div class="h-25 p-3 bg-success">Flex Item A</div>
			<div class="h-25 p-3 bg-warning">Flex Item B</div>
			<div class="h-25 p-3 bg-danger">Flex Item C</div>
		</div>

		<h2>Flex Row</h2>
		<div class="bg-dark p-3 d-flex flex-row">
			<div class="h-25 p-3 bg-success">Flex Item A</div>
			<div class="h-25 p-3 bg-warning">Flex Item B</div>
			<div class="h-25 p-3 bg-danger">Flex Item C</div>
		</div>

		<h2>Flex Row Reverse</h2>
		<div class="bg-dark p-3 d-flex flex-row-reverse">
			<div class="h-25 p-3 bg-success">Flex Item A</div>
			<div class="h-25 p-3 bg-warning">Flex Item B</div>
			<div class="h-25 p-3 bg-danger">Flex Item C</div>
		</div>

		<h2>Creating Space Between Elements</h2>
		<!-- justify-content-around: create spaces around child elements -->
		<div class="bg-dark p-3 d-md-flex justify-content-around">
			<!-- col-md-2: occupy 2 of 12 columns in bootstrap -->
			<div class="p-3 bg-success col-md-2">Card A</div>
			<div class="p-3 bg-warning col-md-2">Card B</div>
			<div class="p-3 bg-danger col-md-2">Card C</div>
		</div>

		<h2>Flexbox With Margin</h2>
		<div class="bg-dark p-3 d-flex">  
			<!-- mr-auto: calculates emptu space in the parent div and distributes it as the margin of the div which has the class (mr-margin) -->
		    <div class="p-3 bg-success mr-auto">Flex Item A</div>
		    <div class="p-3 bg-warning mr-auto">Flex Item B</div>
		    <div class="p-3 bg-danger">Flex Item C</div>
		    <div class="p-3 bg-primary">Flex Item D</div>
		</div>

		<h2>Nested Flex Element</h2>
		<!-- if d-flex is applied to parent item, then only the immediate children are flex, and not to grandchildren -->
		<div class="bg-dark p-3 d-flex"> 
		    <div class="p-3 bg-success mr-auto">Flex Item A</div>
		    <div class="w-50 d-md-flex justify-content-between">
		    	<div class="p-3 bg-warning">Flex Item B</div>
		    	<div class="p-3 bg-danger">Flex Item C</div>
		    	<div class="p-3 bg-primary">Flex Item D</div>
		    </div>
		</div>

	</div>

	<script src="https://cdn.jsdelivr.net/npm/jquery@3.5.1/dist/jquery.slim.min.js" integrity="sha384-DfXdz2htPH0lsSSs5nCTpuj/zy4C+OGpamoFVy38MVBnE+IbbVYUew+OrCXaRkfj" crossorigin="anonymous"></script>
	<script src="https://cdn.jsdelivr.net/npm/bootstrap@4.6.2/dist/js/bootstrap.bundle.min.js" integrity="sha384-Fy6S3B9q64WdZWQUiU+q4/2Lc9npb8tCaSX9FK7E8HnRr0Jz8D6OP9dO5Vg3Q9ct" crossorigin="anonymous"></script>
</body>
</html>